/*
 * Ejercicio5.java
 *
 * Creado el 18 de junio de 2006, 10:33
 */


package metodosLineales.practica5;
import auxiliar.*;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio5 {
    
    public static void main(String[] args) {
        double[][] A = new double[20][20];
        double[] b = new double[20];
        double[] sol = new double[20];
        
        /**
         * Denotemos inicialmente por y_i, i = 1, 2,... , 20, al nmero de 
         * monedas que se guardan en el cajn i. Entonces, de acuerdo con los 
         * datos del problema, se deben satisfacer las siguientes ecuaciones:
         *          (y_{20} + y_1 + y_2)/3 = 11
         *          (y_{i-1} + y_i + y_{i+1)/3 = i+10   i = 2, 3,..., 10
         *          (y_{i-1} + y_i + y_{i+1)/3 = i-10   i = 11, 12,..., 19
         *          (y_{19} + y_{20} + y_1)/3 = 10          
         * Si escribimos ahora x_i = y_{i+1}, i = 0, 1,... , 19, el sistema a 
         * resolver ser
         *          x_{19} + x_0 + x_1 = 33
         *          x_{i-2} + x_{i-1} + x_i = 3(i+10)   i = 2, 3,..., 10
         *          x_{i-2} + x_{i-1} + x_i = 3(i-10)   i = 11, 12,..., 19
         *          x_{18} + x_{19} + x_0 = 30          
         * o, equivalentemente, 
         *          x_{19} + x_0 + x_1 = 33
         *          x_{i-1} + x_i + x_{i+1} = 3(i+11)   i = 1, 3,..., 9
         *          x_{i-1} + x_i + x_{i+1} = 3(i-9)    i = 10, 11,..., 18
         *          x_{18} + x_{19} + x_0 = 30          
         * Se comprobar a continuacin que algunas de las soluciones de este
         * sistema son negativas con lo que el problema de partida, tal y como
         * est planteado, no tiene solucin.
         */
        
        A[0][0] = 1;
        A[0][1] = 1;
        A[0][19] = 1;
        for (int i = 1; i < 19; i++) {
            A[i][i - 1] = 1;
            A[i][i] = 1;
            A[i][i + 1] = 1;
        }
        A[19][0] = 1;
        A[19][18] = 1;
        A[19][19] = 1;
        
        for (int i = 0; i < 10; i++) {
            b[i] = 3 * (i + 11);
        }
        for (int i = 10; i < 20; i++) {
            b[i] =  3 * (i - 9);
        }
        
        System.out.println();
        System.out.println("La matriz A del sistema a resolver es:");
        System.out.println(Matrices.toString(A));        
        System.out.println("El trmino independiente b del sistema "
                + "a resolver es:");
        System.out.println(Matrices.toString(b));
        
        /* Resolvemos el sistema usando el mtodo de Gauss total */                
        try {
            sol = Matrices.gaussTotal(A, b);
            System.out.println();
            System.out.println("La solucin del sistema con gaussTotal es: ");
            System.out.println(Matrices.toString(sol)); 
            System.out.println();
            System.out.println("POR TANTO, EL PROBLEMA PLANTEADO NO TIENE" 
                    + " SOLUCIN");
            System.out.println("(algunos cajones deberan tener un nmero" 
                    + " 'negativo' de monedas)");
            System.out.println();
        } catch(Matrices.ErrorMetodosLineales err) {
        }

    }
    
}
